searchNodes=[{"doc":"Provides functions for signing a map of &quot;claims&quot; into a JWT using a signing key.","ref":"NoWayJose.html","title":"NoWayJose","type":"module"},{"doc":"Generates an RSA private key based on the given bit size and format.","ref":"NoWayJose.html#generate_rsa/2","title":"NoWayJose.generate_rsa/2","type":"function"},{"doc":"Generates a signed JWT from the given claims and signing options. Example # Get the private signing key {:ok, key} = File.read(&quot;private.pem&quot;) # Build your claims claims = %{ &quot;exp&quot; =&gt; 1571065163, &quot;iat&quot; =&gt; 1571061563, &quot;iss&quot; =&gt; &quot;example.com&quot;, &quot;jti&quot; =&gt; &quot;a3a31258-2450-490b-86ed-2b8e67f91e20&quot;, &quot;nbf&quot; =&gt; 1571061563, &quot;scopes&quot; =&gt; [ &quot;posts.r+w&quot;, &quot;comments.r+w&quot; ], &quot;sub&quot; =&gt; &quot;4d3796ca-19e0-40e6-97fe-060c0b7e3ce3&quot; } # Sign the claims into a JWT {:ok, token} = NoWayJose.sign(claims, alg: :rs512, key: key, format: :pem, kid: &quot;1&quot;)","ref":"NoWayJose.html#sign/2","title":"NoWayJose.sign/2","type":"function"},{"doc":"Generates a signed JWT from the given claims and key. Returns a JWT on success and raises an error on error.","ref":"NoWayJose.html#sign!/2","title":"NoWayJose.sign!/2","type":"function"},{"doc":"Algorithm used in JWT signing.","ref":"NoWayJose.html#t:alg/0","title":"NoWayJose.alg/0","type":"type"},{"doc":"A map containing the claims to be encoded. Map keys must be strings.","ref":"NoWayJose.html#t:claims/0","title":"NoWayJose.claims/0","type":"type"},{"doc":"RSA private key. The key can be either DER or PEM encoded. Generating a key der = NoWayJose.generate_rsa(4096, :der) pem = NoWayJose.generate_rsa(4096, :pem) Optionally, you can extract the DER data from a PEM encoded private key in code using the following: {:ok, key} = File.read(&quot;private.pem&quot;) [{:RSAPrivateKey, der, _}] = :public_key.pem_decode(key)","ref":"NoWayJose.html#t:key/0","title":"NoWayJose.key/0","type":"type"},{"doc":"The format of the provided key.","ref":"NoWayJose.html#t:key_format/0","title":"NoWayJose.key_format/0","type":"type"},{"doc":"Key Identifier – Acts as an alias for the key","ref":"NoWayJose.html#t:kid/0","title":"NoWayJose.kid/0","type":"type"},{"doc":"","ref":"NoWayJose.html#t:signing_option/0","title":"NoWayJose.signing_option/0","type":"type"},{"doc":"","ref":"NoWayJose.html#t:signing_options/0","title":"NoWayJose.signing_options/0","type":"type"},{"doc":"JSON Web Token","ref":"NoWayJose.html#t:token/0","title":"NoWayJose.token/0","type":"type"},{"doc":"NoWayJose Rust NIF for JWT signing","ref":"readme.html","title":"NoWayJose","type":"extras"},{"doc":"In its current state, this library only supports signing JWTs using the RS512 algo with a DER or PEM encoded RSA private key.","ref":"readme.html#features","title":"NoWayJose - Features","type":"extras"},{"doc":"def deps do [ {:no_way_jose, &quot;~&gt; 0.2.0&quot;} ] end","ref":"readme.html#installation","title":"NoWayJose - Installation","type":"extras"},{"doc":"In order to sign a JWT an RSA private key must be provided. In code NoWayJose allows generating an RSA private key directly in code by specifying the number of bits and an encoding format (PEM or DER): # PEM encoded RSA private key NoWayJose.generate_rsa(4096, :pem) # DER encoded RSA private key NoWayJose.generate_rsa(4096, :der)","ref":"readme.html#generating-a-key","title":"NoWayJose - Generating a key","type":"extras"},{"doc":"# Read a private signing key from a file {:ok, key} = File.read(&quot;private.der&quot;) # Or generate a new one in code key = NoWayJose.generate_rsa(4096, :der) # Build your claims claims = %{ &quot;exp&quot; =&gt; 1571065163, &quot;iat&quot; =&gt; 1571061563, &quot;iss&quot; =&gt; &quot;example.com&quot;, &quot;jti&quot; =&gt; &quot;a3a31258-2450-490b-86ed-2b8e67f91e20&quot;, &quot;nbf&quot; =&gt; 1571061563, &quot;scopes&quot; =&gt; [ &quot;posts.r+w&quot;, &quot;comments.r+w&quot; ], &quot;sub&quot; =&gt; &quot;4d3796ca-19e0-40e6-97fe-060c0b7e3ce3&quot; } # Sign the claims into a JWT {:ok, token} = NoWayJose.sign(claims, alg: :rs512, format: :der, key: key)","ref":"readme.html#basic-usage","title":"NoWayJose - Basic usage","type":"extras"},{"doc":"Documentation can be be found at https://hexdocs.pm/no_way_jose.","ref":"readme.html#documentation","title":"NoWayJose - Documentation","type":"extras"},{"doc":"Please check the Roadmap if you&#39;re curious about the future of this project.","ref":"readme.html#roadmap","title":"NoWayJose - Roadmap","type":"extras"},{"doc":"A rhyming play on words to indicate that this library does not depend on JOSE.","ref":"readme.html#etymology","title":"NoWayJose - Etymology","type":"extras"},{"doc":"Apache 2.0","ref":"readme.html#license","title":"NoWayJose - License","type":"extras"}]